Gecode::BoolCHB Class Reference
Functionality by programming task » Programming models » Using integer variables and constraints » Branching

Recording CHB for Boolean variables. More...

`#include <int.hh>`

## Public Member Functions

| BoolCHB (void)
| Construct as not yet initialized.
| BoolCHB (const BoolCHB &chb)
| Copy constructor.
BoolCHB & | operator= (const BoolCHB &chb)
| Assignment operator.
| BoolCHB (Home home, const BoolVarArgs &x, BoolBranchMerit bm=nullptr)
| Initialize for Boolean variables x.
void | init (Home home, const BoolVarArgs &x, BoolBranchMerit bm=nullptr)
| Initialize for Boolean variables x.
| CHB (void)
| Construct as not yet intialized.
| CHB (const CHB &a)
| Copy constructor.
CHB & | operator= (const CHB &a)
| Assignment operator.
template<class View>
| CHB (Home home, ViewArray< View > &x, typename BranchTraits< typename View::VarType >::Merit bm)
| Initialize for views x and Q-score as defined by bm.
template<class View>
void | init (Home home, ViewArray< View > &x, typename BranchTraits< typename View::VarType >::Merit bm)
| Initialize for views x and Q-score as defined by bm.
| ~CHB (void)
| Destructor.
double | operator[] (int i) const
| Return chb value at position i.
int | size (void) const
| Return number of chb values.
Public Member Functions inherited from Gecode::SharedHandle
| SharedHandle (void)
| Create shared handle with no object pointing to.
| SharedHandle (SharedHandle::Object *so)
| Create shared handle that points to shared object so.
| SharedHandle (const SharedHandle &sh)
| Copy constructor maintaining reference count.
SharedHandle & | operator= (const SharedHandle &sh)
| Assignment operator maintaining reference count.
| ~SharedHandle (void)
| Destructor that maintains reference count.
| operator bool (void) const
| Whether handle points to an object.

## Additional Inherited Members

static const CHB | def
| Default (empty) chb information.
Protected Member Functions inherited from Gecode::CHB
Storage & | object (void) const
| Return object of correct type.
void | object (Storage &o)
| Set object to o.
void | update (int i)
| Update chb value at position i.
void | acquire (void)
| Acquire mutex.
void | release (void)
| Release mutex.
void | bump (void)
| Bump failure count and alpha.
void | update (int i, bool failed)
| Update chb information at position i.
Protected Member Functions inherited from Gecode::SharedHandle
SharedHandle::Object * | object (void) const
| Access to the shared object.
void | object (SharedHandle::Object *n)
| Modify shared object.
Related Symbols inherited from Gecode::CHB
template<class Char, class Traits>
std::basic_ostream< Char, Traits > & | operator<< (std::basic_ostream< Char, Traits > &os, const CHB &a)
| Print chb values enclosed in curly brackets.

## Detailed Description

Recording CHB for Boolean variables.

Definition at line 4502 of file int.hh.

## Constructor & Destructor Documentation

## BoolCHB() [1/3]

Gecode::BoolCHB::BoolCHB | ( | void |  | ) |

inline

Construct as not yet initialized.

The only member functions that can be used on a constructed but not yet initialized action storage is init or the assignment operator.

Definition at line 50 of file chb.hpp.

## BoolCHB() [2/3]

Gecode::BoolCHB::BoolCHB | ( | const BoolCHB & | chb | ) |

inline

Copy constructor.

Definition at line 53 of file chb.hpp.

## BoolCHB() [3/3]

Gecode::BoolCHB::BoolCHB | ( | Home | home,
|  | const BoolVarArgs & | x,
|  | BoolBranchMerit | bm = nullptr )

Initialize for Boolean variables x.

If the branch merit function bm is different from nullptr, the action for each variable is initialized with the merit returned by bm.

Definition at line 50 of file chb.cpp.

## Member Function Documentation

## operator=()

BoolCHB & Gecode::BoolCHB::operator= | ( | const BoolCHB & | chb | ) |

inline

Assignment operator.

Definition at line 57 of file chb.hpp.

## init()

void Gecode::BoolCHB::init | ( | Home | home,
|  | const BoolVarArgs & | x,
|  | BoolBranchMerit | bm = nullptr )

Initialize for Boolean variables x.

If the branch merit function bm is different from nullptr, the action for each variable is initialized with the merit returned by bm.

This member function can only be used once and only if the action storage has been constructed with the default constructor.

Definition at line 56 of file chb.cpp.

The documentation for this class was generated from the following files:

- gecode/int.hh
- gecode/int/branch/chb.cpp
- gecode/int/branch/chb.hpp